/* tsx-pack v0.0.5 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function escape(str) {
    return str
        .replaceAll('&', '&amp;')
        .replaceAll('<', '&lt;')
        .replaceAll('>', '&gt;')
        .replaceAll("'", '&apos;')
        .replaceAll('"', '&quot;');
}
const voidElements = new Set([
    'area',
    'base',
    'br',
    'col',
    'embed',
    'hr',
    'img',
    'input',
    'keygen',
    'link',
    'menuitem',
    'meta',
    'param',
    'source',
    'track',
    'wbr'
]);
const isObject = (obj) => obj && typeof obj === 'object' && obj !== null;
function jsx(tag, props) {
    const { children } = props;
    let output = '';
    const isTagString = typeof tag === 'string';
    // append opening tag
    if (isTagString) {
        // opening tag starts
        output += `<${tag}`;
        if (props) {
            for (let key in props) {
                // skip children
                if (key === 'children')
                    continue;
                if (isObject(props[key]) || typeof props[key] === 'function') {
                    throw new Error('can not stringify object or function');
                }
                // add attributes
                output += ` ${key.toLowerCase()}="${escape(props[key])}"`;
            }
        }
        //  opening tag ends
        output += `>`;
    }
    // append body if component
    else if (tag !== Fragment) {
        output += tag(props);
    }
    // append content of tag or component
    if (children && (isTagString || tag === Fragment)) {
        if (Array.isArray(children)) {
            const str = children
                .map(child => {
                if (Array.isArray(child))
                    return child.join('');
                return child;
            })
                .join('');
            output += str;
        }
        else {
            output += children + '';
        }
    }
    // close the tag
    if (isTagString && !voidElements.has(tag)) {
        output += `</${tag}>`;
    }
    return output;
}
function Fragment() {
    return null;
}
const jsxs = jsx;

exports.Fragment = Fragment;
exports.escape = escape;
exports.jsx = jsx;
exports.jsxs = jsxs;
exports.voidElements = voidElements;
